package io.dekorate.halkyon.adapter;

import java.nio.file.Path;
import java.util.stream.Collectors;
import io.dekorate.kubernetes.config.Label;
import io.dekorate.halkyon.config.ComponentConfigBuilder;
import java.lang.String;
import io.dekorate.kubernetes.config.Env;
import java.util.Comparator;
import io.dekorate.project.Project;
import io.dekorate.halkyon.annotation.HalkyonComponent;
import io.dekorate.halkyon.config.ComponentConfig;
import io.dekorate.project.BuildInfo;
import io.dekorate.halkyon.model.DeploymentMode;
import io.dekorate.project.ScmInfo;
import java.util.Arrays;
import java.util.Map;

public class ComponentConfigAdapter{



    public static ComponentConfig adapt(HalkyonComponent instance){
            return newBuilder(instance).build();
    }

    public static ComponentConfigBuilder newBuilder(HalkyonComponent instance){
            return new ComponentConfigBuilder(new io.dekorate.halkyon.config.ComponentConfig(null,
            null,
            instance.group(),
            instance.name(),
            instance.version(),
            instance.deploymentMode(),
            instance.exposeService(),
            Arrays.asList(instance.envs()).stream().map(i ->new io.dekorate.kubernetes.config.Env(i.name(),
            i.value(),
            i.secret(),
            i.configmap(),
            i.field())).collect(Collectors.toList()).toArray(new io.dekorate.kubernetes.config.Env[0]),
            Arrays.asList(instance.labels()).stream().map(i ->new io.dekorate.kubernetes.config.Label(i.key(),
            i.value())).collect(Collectors.toList()).toArray(new io.dekorate.kubernetes.config.Label[0]),
            instance.buildType(),
            instance.remote()));
    }

    public static ComponentConfig adapt(Map map){
            return new io.dekorate.halkyon.config.ComponentConfig(
null,
null,
               (String)(map instanceof Map ? ((Map)map).getOrDefault("group", "") : ""),
               (String)(map instanceof Map ? ((Map)map).getOrDefault("name", "") : ""),
               (String)(map instanceof Map ? ((Map)map).getOrDefault("version", "") : ""),
               DeploymentMode.valueOf(String.valueOf(map instanceof Map ? ((Map)map).getOrDefault("deploymentMode","dev") : "dev")),
               Boolean.parseBoolean(String.valueOf(map instanceof Map ? ((Map)map).getOrDefault("exposeService","false") : "false")),
               Arrays.stream((Map[])(map instanceof Map ? ((Map)map).getOrDefault("envs" , new Map[0]) : new Map[0])).map(i ->new io.dekorate.kubernetes.config.Env(
               (String)(i instanceof Map ? ((Map)i).getOrDefault("name", null) : null),
               (String)(i instanceof Map ? ((Map)i).getOrDefault("value", "") : ""),
               (String)(i instanceof Map ? ((Map)i).getOrDefault("secret", "") : ""),
               (String)(i instanceof Map ? ((Map)i).getOrDefault("configmap", "") : ""),
               (String)(i instanceof Map ? ((Map)i).getOrDefault("field", "") : ""))).toArray(size-> new io.dekorate.kubernetes.config.Env[size]),
               Arrays.stream((Map[])(map instanceof Map ? ((Map)map).getOrDefault("labels" , new Map[0]) : new Map[0])).map(i ->new io.dekorate.kubernetes.config.Label(
               (String)(i instanceof Map ? ((Map)i).getOrDefault("key", null) : null),
               (String)(i instanceof Map ? ((Map)i).getOrDefault("value", null) : null))).toArray(size-> new io.dekorate.kubernetes.config.Label[size]),
               (String)(map instanceof Map ? ((Map)map).getOrDefault("buildType", "s2i") : "s2i"),
               (String)(map instanceof Map ? ((Map)map).getOrDefault("remote", "origin") : "origin"));
    }

    public static ComponentConfigBuilder newBuilder(Map map){
            return new ComponentConfigBuilder(new io.dekorate.halkyon.config.ComponentConfig(
null,
null,
               (String)(map instanceof Map ? ((Map)map).getOrDefault("group", "") : ""),
               (String)(map instanceof Map ? ((Map)map).getOrDefault("name", "") : ""),
               (String)(map instanceof Map ? ((Map)map).getOrDefault("version", "") : ""),
               DeploymentMode.valueOf(String.valueOf(map instanceof Map ? ((Map)map).getOrDefault("deploymentMode","dev") : "dev")),
               Boolean.parseBoolean(String.valueOf(map instanceof Map ? ((Map)map).getOrDefault("exposeService","false") : "false")),
               Arrays.stream((Map[])(map instanceof Map ? ((Map)map).getOrDefault("envs" , new Map[0]) : new Map[0])).map(i ->new io.dekorate.kubernetes.config.Env(
               (String)(i instanceof Map ? ((Map)i).getOrDefault("name", null) : null),
               (String)(i instanceof Map ? ((Map)i).getOrDefault("value", "") : ""),
               (String)(i instanceof Map ? ((Map)i).getOrDefault("secret", "") : ""),
               (String)(i instanceof Map ? ((Map)i).getOrDefault("configmap", "") : ""),
               (String)(i instanceof Map ? ((Map)i).getOrDefault("field", "") : ""))).toArray(size-> new io.dekorate.kubernetes.config.Env[size]),
               Arrays.stream((Map[])(map instanceof Map ? ((Map)map).getOrDefault("labels" , new Map[0]) : new Map[0])).map(i ->new io.dekorate.kubernetes.config.Label(
               (String)(i instanceof Map ? ((Map)i).getOrDefault("key", null) : null),
               (String)(i instanceof Map ? ((Map)i).getOrDefault("value", null) : null))).toArray(size-> new io.dekorate.kubernetes.config.Label[size]),
               (String)(map instanceof Map ? ((Map)map).getOrDefault("buildType", "s2i") : "s2i"),
               (String)(map instanceof Map ? ((Map)map).getOrDefault("remote", "origin") : "origin")));
    }




}
