package io.dekorate.halkyon.adapter;

import java.nio.file.Path;
import java.util.stream.Collectors;
import io.dekorate.halkyon.config.LinkConfigBuilder;
import io.dekorate.halkyon.config.LinkConfig;
import io.dekorate.halkyon.annotation.HalkyonLink;
import java.lang.String;
import io.dekorate.kubernetes.config.Env;
import java.util.Comparator;
import io.dekorate.project.Project;
import io.dekorate.halkyon.model.Type;
import io.dekorate.project.BuildInfo;
import io.dekorate.project.ScmInfo;
import java.util.Arrays;
import java.util.Map;

public class LinkConfigAdapter{



    public static LinkConfig adapt(HalkyonLink instance){
            return newBuilder(instance).build();
    }

    public static LinkConfigBuilder newBuilder(HalkyonLink instance){
            return new LinkConfigBuilder(new io.dekorate.halkyon.config.LinkConfig(null,
            null,
            instance.name(),
            instance.componentName(),
            instance.type(),
            instance.ref(),
            Arrays.asList(instance.envs()).stream().map(i ->new io.dekorate.kubernetes.config.Env(i.name(),
            i.value(),
            i.secret(),
            i.configmap(),
            i.field())).collect(Collectors.toList()).toArray(new io.dekorate.kubernetes.config.Env[0])));
    }

    public static LinkConfig adapt(Map map){
            return new io.dekorate.halkyon.config.LinkConfig(
null,
null,
               (String)(map instanceof Map ? ((Map)map).getOrDefault("name", "") : ""),
               (String)(map instanceof Map ? ((Map)map).getOrDefault("componentName", null) : null),
               Type.valueOf(String.valueOf(map instanceof Map ? ((Map)map).getOrDefault("type","Env") : "Env")),
               (String)(map instanceof Map ? ((Map)map).getOrDefault("ref", "") : ""),
               Arrays.stream((Map[])(map instanceof Map ? ((Map)map).getOrDefault("envs" , new Map[0]) : new Map[0])).map(i ->new io.dekorate.kubernetes.config.Env(
               (String)(i instanceof Map ? ((Map)i).getOrDefault("name", null) : null),
               (String)(i instanceof Map ? ((Map)i).getOrDefault("value", "") : ""),
               (String)(i instanceof Map ? ((Map)i).getOrDefault("secret", "") : ""),
               (String)(i instanceof Map ? ((Map)i).getOrDefault("configmap", "") : ""),
               (String)(i instanceof Map ? ((Map)i).getOrDefault("field", "") : ""))).toArray(size-> new io.dekorate.kubernetes.config.Env[size]));
    }

    public static LinkConfigBuilder newBuilder(Map map){
            return new LinkConfigBuilder(new io.dekorate.halkyon.config.LinkConfig(
null,
null,
               (String)(map instanceof Map ? ((Map)map).getOrDefault("name", "") : ""),
               (String)(map instanceof Map ? ((Map)map).getOrDefault("componentName", null) : null),
               Type.valueOf(String.valueOf(map instanceof Map ? ((Map)map).getOrDefault("type","Env") : "Env")),
               (String)(map instanceof Map ? ((Map)map).getOrDefault("ref", "") : ""),
               Arrays.stream((Map[])(map instanceof Map ? ((Map)map).getOrDefault("envs" , new Map[0]) : new Map[0])).map(i ->new io.dekorate.kubernetes.config.Env(
               (String)(i instanceof Map ? ((Map)i).getOrDefault("name", null) : null),
               (String)(i instanceof Map ? ((Map)i).getOrDefault("value", "") : ""),
               (String)(i instanceof Map ? ((Map)i).getOrDefault("secret", "") : ""),
               (String)(i instanceof Map ? ((Map)i).getOrDefault("configmap", "") : ""),
               (String)(i instanceof Map ? ((Map)i).getOrDefault("field", "") : ""))).toArray(size-> new io.dekorate.kubernetes.config.Env[size])));
    }




}
