package io.dekorate.halkyon.config;

import io.dekorate.project.Project;
import io.dekorate.halkyon.model.Type;
import io.dekorate.kubernetes.config.ConfigKey;
import io.dekorate.kubernetes.config.Configuration;
import java.lang.Object;
import java.lang.String;
import io.dekorate.kubernetes.config.Env;
import java.util.Map;
import io.sundr.builder.annotations.Buildable;

@io.sundr.builder.annotations.Buildable(builderPackage = "io.dekorate.deps.kubernetes.api.builder") public class LinkConfig extends Configuration{

    private String name = "";
    private String componentName;
    private Type type = io.dekorate.halkyon.model.Type.Env;
    private String ref = "";
    private io.dekorate.kubernetes.config.Env[] envs = new io.dekorate.kubernetes.config.Env[0];

    public LinkConfig(){
    }
    public LinkConfig(Project project,Map<ConfigKey,Object> attributes,String name,String componentName,Type type,String ref,io.dekorate.kubernetes.config.Env[] envs){
            super(project, attributes);
            this.name = name != null ? name : "";
            this.componentName = componentName;
            this.type = type != null ? type : io.dekorate.halkyon.model.Type.Env;
            this.ref = ref != null ? ref : "";
            this.envs = envs != null ? envs : new io.dekorate.kubernetes.config.Env[0];
    }

    public String getName(){
            return this.name;
    }

    public String getComponentName(){
            return this.componentName;
    }

    public Type getType(){
            return this.type;
    }

    public String getRef(){
            return this.ref;
    }

    public io.dekorate.kubernetes.config.Env[] getEnvs(){
            return this.envs;
    }

    public static LinkConfigBuilder newLinkConfigBuilder(){
            return new io.dekorate.halkyon.config.LinkConfigBuilder();
    }




}
