package io.dekorate.halkyon.config;

import io.dekorate.deps.kubernetes.api.builder.VisitableBuilder;
import java.lang.Object;
import java.lang.Boolean;

public class LinkConfigBuilder extends LinkConfigFluentImpl<LinkConfigBuilder> implements VisitableBuilder<LinkConfig,LinkConfigBuilder>{

    LinkConfigFluent<?> fluent;
    Boolean validationEnabled;

    public LinkConfigBuilder(){
            this(true);
    }
    public LinkConfigBuilder(Boolean validationEnabled){
            this(new LinkConfig(), validationEnabled);
    }
    public LinkConfigBuilder(LinkConfigFluent<?> fluent){
            this(fluent, true);
    }
    public LinkConfigBuilder(LinkConfigFluent<?> fluent,Boolean validationEnabled){
            this(fluent, new LinkConfig(), validationEnabled);
    }
    public LinkConfigBuilder(LinkConfigFluent<?> fluent,LinkConfig instance){
            this(fluent, instance, true);
    }
    public LinkConfigBuilder(LinkConfigFluent<?> fluent,LinkConfig instance,Boolean validationEnabled){
            this.fluent = fluent; 
            fluent.withProject(instance.getProject()); 
            fluent.withAttributes(instance.getAttributes()); 
            fluent.withName(instance.getName()); 
            fluent.withComponentName(instance.getComponentName()); 
            fluent.withType(instance.getType()); 
            fluent.withRef(instance.getRef()); 
            fluent.withEnvs(instance.getEnvs()); 
            this.validationEnabled = validationEnabled; 
    }
    public LinkConfigBuilder(LinkConfig instance){
            this(instance,true);
    }
    public LinkConfigBuilder(LinkConfig instance,Boolean validationEnabled){
            this.fluent = this; 
            this.withProject(instance.getProject()); 
            this.withAttributes(instance.getAttributes()); 
            this.withName(instance.getName()); 
            this.withComponentName(instance.getComponentName()); 
            this.withType(instance.getType()); 
            this.withRef(instance.getRef()); 
            this.withEnvs(instance.getEnvs()); 
            this.validationEnabled = validationEnabled; 
    }

    public EditableLinkConfig build(){
            EditableLinkConfig buildable = new EditableLinkConfig(fluent.getProject(),fluent.getAttributes(),fluent.getName(),fluent.getComponentName(),fluent.getType(),fluent.getRef(),fluent.getEnvs());
            return buildable;
    }

    public boolean equals(Object o){
            if (this == o) return true;
            if (o == null || getClass() != o.getClass()) return false;
            if (!super.equals(o)) return false;
            LinkConfigBuilder that = (LinkConfigBuilder) o;
            if (fluent != null &&fluent != this ? !fluent.equals(that.fluent) :that.fluent != null &&fluent != this ) return false;

            if (validationEnabled != null ? !validationEnabled.equals(that.validationEnabled) :that.validationEnabled != null) return false;
            return true;
    }




}
