package io.dekorate.halkyon.config;

import io.dekorate.deps.kubernetes.api.builder.VisitableBuilder;
import io.dekorate.kubernetes.config.ConfigKey;
import java.lang.StringBuilder;
import io.dekorate.kubernetes.config.EnvFluent;
import io.dekorate.deps.kubernetes.api.builder.Nested;
import java.util.ArrayList;
import io.dekorate.kubernetes.config.ConfigurationFluent;
import java.lang.String;
import io.dekorate.kubernetes.config.Env;
import io.dekorate.deps.kubernetes.api.builder.Predicate;
import io.dekorate.project.Project;
import io.dekorate.halkyon.model.Type;
import java.lang.StringBuffer;
import io.dekorate.kubernetes.config.EnvBuilder;
import java.lang.Deprecated;
import java.util.Iterator;
import java.util.Collection;
import java.lang.Object;
import java.lang.Boolean;
import java.util.Map;

public interface LinkConfigFluent<A extends LinkConfigFluent<A>> extends ConfigurationFluent<A>{


    public String getName();
    public A withName(String name);
    public Boolean hasName();
    public A withNewName(String arg1);
    public A withNewName(StringBuilder arg1);
    public A withNewName(StringBuffer arg1);
    public String getComponentName();
    public A withComponentName(String componentName);
    public Boolean hasComponentName();
    public A withNewComponentName(String arg1);
    public A withNewComponentName(StringBuilder arg1);
    public A withNewComponentName(StringBuffer arg1);
    public Type getType();
    public A withType(Type type);
    public Boolean hasType();
    public String getRef();
    public A withRef(String ref);
    public Boolean hasRef();
    public A withNewRef(String arg1);
    public A withNewRef(StringBuilder arg1);
    public A withNewRef(StringBuffer arg1);
    public A withEnvs(io.dekorate.kubernetes.config.Env... envs);
    
/**
 * This method has been deprecated, please use method buildEnvs instead.
 */
@Deprecated public io.dekorate.kubernetes.config.Env[] getEnvs();
    public io.dekorate.kubernetes.config.Env[] buildEnvs();
    public io.dekorate.kubernetes.config.Env buildEnv(int index);
    public io.dekorate.kubernetes.config.Env buildFirstEnv();
    public io.dekorate.kubernetes.config.Env buildLastEnv();
    public io.dekorate.kubernetes.config.Env buildMatchingEnv(io.dekorate.deps.kubernetes.api.builder.Predicate<io.dekorate.kubernetes.config.EnvBuilder> predicate);
    public Boolean hasMatchingEnv(io.dekorate.deps.kubernetes.api.builder.Predicate<io.dekorate.kubernetes.config.EnvBuilder> predicate);
    public A addToEnvs(int index,io.dekorate.kubernetes.config.Env item);
    public A setToEnvs(int index,io.dekorate.kubernetes.config.Env item);
    public A addToEnvs(io.dekorate.kubernetes.config.Env... items);
    public A addAllToConfigEnvs(Collection<io.dekorate.kubernetes.config.Env> items);
    public A removeFromEnvs(io.dekorate.kubernetes.config.Env... items);
    public A removeAllFromConfigEnvs(Collection<io.dekorate.kubernetes.config.Env> items);
    public A removeMatchingFromConfigEnvs(io.dekorate.deps.kubernetes.api.builder.Predicate<io.dekorate.kubernetes.config.EnvBuilder> predicate);
    public Boolean hasEnvs();
    public A addNewConfigEnv(String name,String value,String secret,String configmap,String field);
    public LinkConfigFluent.ConfigEnvsNested<A> addNewConfigEnv();
    public LinkConfigFluent.ConfigEnvsNested<A> addNewEnvLike(io.dekorate.kubernetes.config.Env item);
    public LinkConfigFluent.ConfigEnvsNested<A> setNewEnvLike(int index,io.dekorate.kubernetes.config.Env item);
    public LinkConfigFluent.ConfigEnvsNested<A> editEnv(int index);
    public LinkConfigFluent.ConfigEnvsNested<A> editFirstEnv();
    public LinkConfigFluent.ConfigEnvsNested<A> editLastEnv();
    public LinkConfigFluent.ConfigEnvsNested<A> editMatchingEnv(io.dekorate.deps.kubernetes.api.builder.Predicate<io.dekorate.kubernetes.config.EnvBuilder> predicate);

    public interface ConfigEnvsNested<N> extends io.dekorate.deps.kubernetes.api.builder.Nested<N>,io.dekorate.kubernetes.config.EnvFluent<LinkConfigFluent.ConfigEnvsNested<N>>{

        
    public N and();    public N endConfigEnv();
}


}
