package io.dekorate.halkyon.model;

import io.dekorate.deps.kubernetes.api.model.ObjectMeta;
import io.dekorate.deps.jackson.annotation.JsonProperty;
import java.lang.StringBuilder;
import io.dekorate.deps.kubernetes.api.builder.Fluent;
import io.dekorate.deps.kubernetes.api.builder.Nested;
import java.lang.String;
import io.dekorate.deps.kubernetes.api.model.ObjectMetaBuilder;
import java.lang.StringBuffer;
import io.dekorate.deps.kubernetes.api.model.ObjectMetaFluent;
import java.lang.Deprecated;
import java.lang.Boolean;

public interface LinkFluent<A extends LinkFluent<A>> extends Fluent<A>{


    public String getApiVersion();
    public A withApiVersion(String apiVersion);
    public Boolean hasApiVersion();
    public A withNewApiVersion(String arg1);
    public A withNewApiVersion(StringBuilder arg1);
    public A withNewApiVersion(StringBuffer arg1);
    public String getKind();
    public A withKind(String kind);
    public Boolean hasKind();
    public A withNewKind(String arg1);
    public A withNewKind(StringBuilder arg1);
    public A withNewKind(StringBuffer arg1);
    
/**
 * This method has been deprecated, please use method buildMetadata instead.
 * @return The buildable object.
 */
@Deprecated public ObjectMeta getMetadata();
    public ObjectMeta buildMetadata();
    public A withMetadata(ObjectMeta metadata);
    public Boolean hasMetadata();
    public LinkFluent.MetadataNested<A> withNewMetadata();
    public LinkFluent.MetadataNested<A> withNewMetadataLike(ObjectMeta item);
    public LinkFluent.MetadataNested<A> editMetadata();
    public LinkFluent.MetadataNested<A> editOrNewMetadata();
    public LinkFluent.MetadataNested<A> editOrNewMetadataLike(ObjectMeta item);
    
/**
 * This method has been deprecated, please use method buildSpec instead.
 * @return The buildable object.
 */
@Deprecated public LinkSpec getSpec();
    public LinkSpec buildSpec();
    public A withSpec(LinkSpec spec);
    public Boolean hasSpec();
    public LinkFluent.SpecNested<A> withNewSpec();
    public LinkFluent.SpecNested<A> withNewSpecLike(LinkSpec item);
    public LinkFluent.SpecNested<A> editSpec();
    public LinkFluent.SpecNested<A> editOrNewSpec();
    public LinkFluent.SpecNested<A> editOrNewSpecLike(LinkSpec item);
    
/**
 * This method has been deprecated, please use method buildStatus instead.
 * @return The buildable object.
 */
@Deprecated public LinkStatus getStatus();
    public LinkStatus buildStatus();
    public A withStatus(LinkStatus status);
    public Boolean hasStatus();
    public A withNewStatus(String phase);
    public LinkFluent.StatusNested<A> withNewStatus();
    public LinkFluent.StatusNested<A> withNewStatusLike(LinkStatus item);
    public LinkFluent.StatusNested<A> editStatus();
    public LinkFluent.StatusNested<A> editOrNewStatus();
    public LinkFluent.StatusNested<A> editOrNewStatusLike(LinkStatus item);

    public interface MetadataNested<N> extends Nested<N>,ObjectMetaFluent<LinkFluent.MetadataNested<N>>{

        
    public N and();    public N endMetadata();
}
    public interface SpecNested<N> extends Nested<N>,LinkSpecFluent<LinkFluent.SpecNested<N>>{

        
    public N and();    public N endSpec();
}
    public interface StatusNested<N> extends Nested<N>,LinkStatusFluent<LinkFluent.StatusNested<N>>{

        
    public N and();    public N endStatus();
}


}
