package io.dekorate.halkyon.model;

import io.dekorate.deps.jackson.annotation.JsonProperty;
import java.lang.StringBuilder;
import io.dekorate.deps.kubernetes.api.builder.Nested;
import java.lang.String;
import java.lang.Deprecated;
import io.dekorate.deps.kubernetes.api.builder.BaseFluent;
import java.lang.Boolean;
import io.dekorate.deps.kubernetes.api.model.ObjectMeta;
import io.dekorate.deps.kubernetes.api.model.ObjectMetaFluentImpl;
import io.dekorate.deps.kubernetes.api.model.ObjectMetaBuilder;
import java.lang.StringBuffer;
import java.lang.Object;

public class LinkFluentImpl<A extends LinkFluent<A>> extends BaseFluent<A> implements LinkFluent<A>{

    private String apiVersion;
    private String kind;
    private ObjectMetaBuilder metadata;
    private LinkSpecBuilder spec;
    private LinkStatusBuilder status;

    public LinkFluentImpl(){
    }
    public LinkFluentImpl(Link instance){
            this.withApiVersion(instance.getApiVersion()); 
            this.withKind(instance.getKind()); 
            this.withMetadata(instance.getMetadata()); 
            this.withSpec(instance.getSpec()); 
            this.withStatus(instance.getStatus()); 
    }

    public String getApiVersion(){
            return this.apiVersion;
    }

    public A withApiVersion(String apiVersion){
            this.apiVersion=apiVersion; return (A) this;
    }

    public Boolean hasApiVersion(){
            return this.apiVersion != null;
    }

    public A withNewApiVersion(String arg1){
            return (A)withApiVersion(new String(arg1));
    }

    public A withNewApiVersion(StringBuilder arg1){
            return (A)withApiVersion(new String(arg1));
    }

    public A withNewApiVersion(StringBuffer arg1){
            return (A)withApiVersion(new String(arg1));
    }

    public String getKind(){
            return this.kind;
    }

    public A withKind(String kind){
            this.kind=kind; return (A) this;
    }

    public Boolean hasKind(){
            return this.kind != null;
    }

    public A withNewKind(String arg1){
            return (A)withKind(new String(arg1));
    }

    public A withNewKind(StringBuilder arg1){
            return (A)withKind(new String(arg1));
    }

    public A withNewKind(StringBuffer arg1){
            return (A)withKind(new String(arg1));
    }

    
/**
 * This method has been deprecated, please use method buildMetadata instead.
 * @return The buildable object.
 */
@Deprecated public ObjectMeta getMetadata(){
            return this.metadata!=null?this.metadata.build():null;
    }

    public ObjectMeta buildMetadata(){
            return this.metadata!=null?this.metadata.build():null;
    }

    public A withMetadata(ObjectMeta metadata){
            _visitables.get("metadata").remove(this.metadata);
            if (metadata!=null){ this.metadata= new ObjectMetaBuilder(metadata); _visitables.get("metadata").add(this.metadata);} return (A) this;
    }

    public Boolean hasMetadata(){
            return this.metadata != null;
    }

    public LinkFluent.MetadataNested<A> withNewMetadata(){
            return new MetadataNestedImpl();
    }

    public LinkFluent.MetadataNested<A> withNewMetadataLike(ObjectMeta item){
            return new MetadataNestedImpl(item);
    }

    public LinkFluent.MetadataNested<A> editMetadata(){
            return withNewMetadataLike(getMetadata());
    }

    public LinkFluent.MetadataNested<A> editOrNewMetadata(){
            return withNewMetadataLike(getMetadata() != null ? getMetadata(): new ObjectMetaBuilder().build());
    }

    public LinkFluent.MetadataNested<A> editOrNewMetadataLike(ObjectMeta item){
            return withNewMetadataLike(getMetadata() != null ? getMetadata(): item);
    }

    
/**
 * This method has been deprecated, please use method buildSpec instead.
 * @return The buildable object.
 */
@Deprecated public LinkSpec getSpec(){
            return this.spec!=null?this.spec.build():null;
    }

    public LinkSpec buildSpec(){
            return this.spec!=null?this.spec.build():null;
    }

    public A withSpec(LinkSpec spec){
            _visitables.get("spec").remove(this.spec);
            if (spec!=null){ this.spec= new LinkSpecBuilder(spec); _visitables.get("spec").add(this.spec);} return (A) this;
    }

    public Boolean hasSpec(){
            return this.spec != null;
    }

    public LinkFluent.SpecNested<A> withNewSpec(){
            return new SpecNestedImpl();
    }

    public LinkFluent.SpecNested<A> withNewSpecLike(LinkSpec item){
            return new SpecNestedImpl(item);
    }

    public LinkFluent.SpecNested<A> editSpec(){
            return withNewSpecLike(getSpec());
    }

    public LinkFluent.SpecNested<A> editOrNewSpec(){
            return withNewSpecLike(getSpec() != null ? getSpec(): new LinkSpecBuilder().build());
    }

    public LinkFluent.SpecNested<A> editOrNewSpecLike(LinkSpec item){
            return withNewSpecLike(getSpec() != null ? getSpec(): item);
    }

    
/**
 * This method has been deprecated, please use method buildStatus instead.
 * @return The buildable object.
 */
@Deprecated public LinkStatus getStatus(){
            return this.status!=null?this.status.build():null;
    }

    public LinkStatus buildStatus(){
            return this.status!=null?this.status.build():null;
    }

    public A withStatus(LinkStatus status){
            _visitables.get("status").remove(this.status);
            if (status!=null){ this.status= new LinkStatusBuilder(status); _visitables.get("status").add(this.status);} return (A) this;
    }

    public Boolean hasStatus(){
            return this.status != null;
    }

    public A withNewStatus(String phase){
            return (A)withStatus(new LinkStatus(phase));
    }

    public LinkFluent.StatusNested<A> withNewStatus(){
            return new StatusNestedImpl();
    }

    public LinkFluent.StatusNested<A> withNewStatusLike(LinkStatus item){
            return new StatusNestedImpl(item);
    }

    public LinkFluent.StatusNested<A> editStatus(){
            return withNewStatusLike(getStatus());
    }

    public LinkFluent.StatusNested<A> editOrNewStatus(){
            return withNewStatusLike(getStatus() != null ? getStatus(): new LinkStatusBuilder().build());
    }

    public LinkFluent.StatusNested<A> editOrNewStatusLike(LinkStatus item){
            return withNewStatusLike(getStatus() != null ? getStatus(): item);
    }

    public boolean equals(Object o){
            if (this == o) return true;
            if (o == null || getClass() != o.getClass()) return false;
            LinkFluentImpl that = (LinkFluentImpl) o;
            if (apiVersion != null ? !apiVersion.equals(that.apiVersion) :that.apiVersion != null) return false;
            if (kind != null ? !kind.equals(that.kind) :that.kind != null) return false;
            if (metadata != null ? !metadata.equals(that.metadata) :that.metadata != null) return false;
            if (spec != null ? !spec.equals(that.spec) :that.spec != null) return false;
            if (status != null ? !status.equals(that.status) :that.status != null) return false;
            return true;
    }


    public class MetadataNestedImpl<N> extends ObjectMetaFluentImpl<LinkFluent.MetadataNested<N>> implements LinkFluent.MetadataNested<N>,Nested<N>{

            private final ObjectMetaBuilder builder;
    
            MetadataNestedImpl(ObjectMeta item){
                    this.builder = new ObjectMetaBuilder(this, item);
            }
            MetadataNestedImpl(){
                    this.builder = new ObjectMetaBuilder(this);
            }
    
    public N and(){
            return (N) LinkFluentImpl.this.withMetadata(builder.build());
    }
    public N endMetadata(){
            return and();
    }

}
    public class SpecNestedImpl<N> extends LinkSpecFluentImpl<LinkFluent.SpecNested<N>> implements LinkFluent.SpecNested<N>,Nested<N>{

            private final LinkSpecBuilder builder;
    
            SpecNestedImpl(LinkSpec item){
                    this.builder = new LinkSpecBuilder(this, item);
            }
            SpecNestedImpl(){
                    this.builder = new LinkSpecBuilder(this);
            }
    
    public N and(){
            return (N) LinkFluentImpl.this.withSpec(builder.build());
    }
    public N endSpec(){
            return and();
    }

}
    public class StatusNestedImpl<N> extends LinkStatusFluentImpl<LinkFluent.StatusNested<N>> implements LinkFluent.StatusNested<N>,Nested<N>{

            private final LinkStatusBuilder builder;
    
            StatusNestedImpl(LinkStatus item){
                    this.builder = new LinkStatusBuilder(this, item);
            }
            StatusNestedImpl(){
                    this.builder = new LinkStatusBuilder(this);
            }
    
    public N and(){
            return (N) LinkFluentImpl.this.withStatus(builder.build());
    }
    public N endStatus(){
            return and();
    }

}


}
