package io.dekorate.halkyon.model;

import io.dekorate.deps.kubernetes.api.builder.VisitableBuilder;
import java.lang.Object;
import java.lang.Boolean;

public class LinkListBuilder extends LinkListFluentImpl<LinkListBuilder> implements VisitableBuilder<LinkList,LinkListBuilder>{

    LinkListFluent<?> fluent;
    Boolean validationEnabled;

    public LinkListBuilder(){
            this(true);
    }
    public LinkListBuilder(Boolean validationEnabled){
            this(new LinkList(), validationEnabled);
    }
    public LinkListBuilder(LinkListFluent<?> fluent){
            this(fluent, true);
    }
    public LinkListBuilder(LinkListFluent<?> fluent,Boolean validationEnabled){
            this(fluent, new LinkList(), validationEnabled);
    }
    public LinkListBuilder(LinkListFluent<?> fluent,LinkList instance){
            this(fluent, instance, true);
    }
    public LinkListBuilder(LinkListFluent<?> fluent,LinkList instance,Boolean validationEnabled){
            this.fluent = fluent; 
            fluent.withApiVersion(instance.getApiVersion()); 
            fluent.withItems(instance.getItems()); 
            fluent.withKind(instance.getKind()); 
            fluent.withMetadata(instance.getMetadata()); 
            this.validationEnabled = validationEnabled; 
    }
    public LinkListBuilder(LinkList instance){
            this(instance,true);
    }
    public LinkListBuilder(LinkList instance,Boolean validationEnabled){
            this.fluent = this; 
            this.withApiVersion(instance.getApiVersion()); 
            this.withItems(instance.getItems()); 
            this.withKind(instance.getKind()); 
            this.withMetadata(instance.getMetadata()); 
            this.validationEnabled = validationEnabled; 
    }

    public LinkList build(){
            LinkList buildable = new LinkList(fluent.getApiVersion(),fluent.getItems(),fluent.getKind(),fluent.getMetadata());
            return buildable;
    }

    public boolean equals(Object o){
            if (this == o) return true;
            if (o == null || getClass() != o.getClass()) return false;
            if (!super.equals(o)) return false;
            LinkListBuilder that = (LinkListBuilder) o;
            if (fluent != null &&fluent != this ? !fluent.equals(that.fluent) :that.fluent != null &&fluent != this ) return false;

            if (validationEnabled != null ? !validationEnabled.equals(that.validationEnabled) :that.validationEnabled != null) return false;
            return true;
    }




}
