package io.dekorate.halkyon.model;

import io.dekorate.deps.kubernetes.api.builder.VisitableBuilder;
import java.lang.Object;
import java.lang.Boolean;

public class LinkSpecBuilder extends LinkSpecFluentImpl<LinkSpecBuilder> implements VisitableBuilder<LinkSpec,LinkSpecBuilder>{

    LinkSpecFluent<?> fluent;
    Boolean validationEnabled;

    public LinkSpecBuilder(){
            this(true);
    }
    public LinkSpecBuilder(Boolean validationEnabled){
            this(new LinkSpec(), validationEnabled);
    }
    public LinkSpecBuilder(LinkSpecFluent<?> fluent){
            this(fluent, true);
    }
    public LinkSpecBuilder(LinkSpecFluent<?> fluent,Boolean validationEnabled){
            this(fluent, new LinkSpec(), validationEnabled);
    }
    public LinkSpecBuilder(LinkSpecFluent<?> fluent,LinkSpec instance){
            this(fluent, instance, true);
    }
    public LinkSpecBuilder(LinkSpecFluent<?> fluent,LinkSpec instance,Boolean validationEnabled){
            this.fluent = fluent; 
            fluent.withComponentName(instance.getComponentName()); 
            fluent.withType(instance.getType()); 
            fluent.withRef(instance.getRef()); 
            fluent.withEnvs(instance.getEnvs()); 
            this.validationEnabled = validationEnabled; 
    }
    public LinkSpecBuilder(LinkSpec instance){
            this(instance,true);
    }
    public LinkSpecBuilder(LinkSpec instance,Boolean validationEnabled){
            this.fluent = this; 
            this.withComponentName(instance.getComponentName()); 
            this.withType(instance.getType()); 
            this.withRef(instance.getRef()); 
            this.withEnvs(instance.getEnvs()); 
            this.validationEnabled = validationEnabled; 
    }

    public LinkSpec build(){
            LinkSpec buildable = new LinkSpec(fluent.getComponentName(),fluent.getType(),fluent.getRef(),fluent.getEnvs());
            return buildable;
    }

    public boolean equals(Object o){
            if (this == o) return true;
            if (o == null || getClass() != o.getClass()) return false;
            if (!super.equals(o)) return false;
            LinkSpecBuilder that = (LinkSpecBuilder) o;
            if (fluent != null &&fluent != this ? !fluent.equals(that.fluent) :that.fluent != null &&fluent != this ) return false;

            if (validationEnabled != null ? !validationEnabled.equals(that.validationEnabled) :that.validationEnabled != null) return false;
            return true;
    }




}
