package io.dekorate.halkyon.model;

import io.dekorate.deps.kubernetes.api.builder.VisitableBuilder;
import java.lang.Object;
import java.lang.Boolean;

public class LinkStatusBuilder extends LinkStatusFluentImpl<LinkStatusBuilder> implements VisitableBuilder<LinkStatus,LinkStatusBuilder>{

    LinkStatusFluent<?> fluent;
    Boolean validationEnabled;

    public LinkStatusBuilder(){
            this(true);
    }
    public LinkStatusBuilder(Boolean validationEnabled){
            this(new LinkStatus(), validationEnabled);
    }
    public LinkStatusBuilder(LinkStatusFluent<?> fluent){
            this(fluent, true);
    }
    public LinkStatusBuilder(LinkStatusFluent<?> fluent,Boolean validationEnabled){
            this(fluent, new LinkStatus(), validationEnabled);
    }
    public LinkStatusBuilder(LinkStatusFluent<?> fluent,LinkStatus instance){
            this(fluent, instance, true);
    }
    public LinkStatusBuilder(LinkStatusFluent<?> fluent,LinkStatus instance,Boolean validationEnabled){
            this.fluent = fluent; 
            fluent.withPhase(instance.getPhase()); 
            this.validationEnabled = validationEnabled; 
    }
    public LinkStatusBuilder(LinkStatus instance){
            this(instance,true);
    }
    public LinkStatusBuilder(LinkStatus instance,Boolean validationEnabled){
            this.fluent = this; 
            this.withPhase(instance.getPhase()); 
            this.validationEnabled = validationEnabled; 
    }

    public LinkStatus build(){
            LinkStatus buildable = new LinkStatus(fluent.getPhase());
            return buildable;
    }

    public boolean equals(Object o){
            if (this == o) return true;
            if (o == null || getClass() != o.getClass()) return false;
            if (!super.equals(o)) return false;
            LinkStatusBuilder that = (LinkStatusBuilder) o;
            if (fluent != null &&fluent != this ? !fluent.equals(that.fluent) :that.fluent != null &&fluent != this ) return false;

            if (validationEnabled != null ? !validationEnabled.equals(that.validationEnabled) :that.validationEnabled != null) return false;
            return true;
    }




}
